/*
 * Main include file for BibTeX in C.
 *
 * Tim Morgan  2/15/88
 * Eduardo Krell 4/21/88
 */

#include <stdio.h>
#include <setjmp.h>
#include "site.h"

#undef	STAT
#undef	DEBUG

extern char *strncpy();

typedef FILE *file_ptr;
typedef FILE *palphafile;
#define	incr(x)	++(x)
#define	decr(x)	--(x)
extern int testaccess();
#define	true	1
#define	false	0
#define rewrite(f,n)	f = openf(n, "w")
#define	reset(f,n)	f = openf(n, "r")
#define	aclose(f)	if (f) (void) fclose(f)
#define	chr(x)		(x)
extern void lineread(), setpaths();
#define readln(f)	{register c; while ((c=getc(f))!='\n' && c!=EOF); }
extern FILE *openf();
#define	uexit(x)	exit((int) (x))
#define	eof(f)		feof(f)
#define	Fputs(stream, s)	(void) fputs(s, stream)
#define printstr(s,c)	fprintf(logfile,"%s%c",s,c);fprintf(stdout,"%s%c",s,c)

extern char **gargv;
extern int gargc;

#define bufsize 3000 
#define minprintline 3 
#define maxprintline 79 
#define auxstacksize 20 
#define maxbibfiles 20 
#define poolsize 65530L
#define maxstrings 4000 
#define maxcites 750 
#define mincrossrefs 2 
#define wizfnspace 3000 
#define singlefnspace 100 
#define maxentints 3000 
#define maxentstrs 3000 
#define entstrsize 100 
#define globstrsize 1000 
#define maxfields 17250 
#define litstksize 100 
#define numbltinfns 37 
typedef schar ASCIIcode  ; 
typedef schar lextype  ; 
typedef schar idtype  ; 
typedef file_ptr /* of  char */ alphafile  ; 
typedef integer bufpointer  ; 
typedef ASCIIcode *buftype; 
typedef integer poolpointer  ; 
typedef integer strnumber  ; 
typedef short hashloc  ; 
typedef short hashpointer  ; 
typedef schar strilk  ; 
typedef schar pdsloc  ; 
typedef schar pdslen  ; 
typedef char pdstype [13] ; 
typedef integer auxnumber  ; 
typedef integer bibnumber  ; 
typedef integer citenumber  ; 
typedef schar fnclass  ; 
typedef integer wizfnloc  ; 
typedef integer intentloc  ; 
typedef integer strentloc  ; 
typedef schar strglobloc  ; 
typedef integer fieldloc  ; 
typedef short hashptr2  ; 
typedef integer litstkloc  ; 
typedef schar stktype  ; 
typedef integer bltinrange  ; 
/*
 *  Externals for directory search stuff ... jdl 
 */
extern char		MacVolumeName[100];
extern int		Folders[3];
extern FInfo 	AuxFileInfo;
/*  done ... jdl */