#include "bibtex.h"
#include "bibtex.p"
#include "globals.h"
#include "coerce.h"

zexecutefn ( exfnloc ) 
hashloc exfnloc ; 
{/* 51 */ integer rpoplt1, rpoplt2  ; 
  stktype rpoptp1, rpoptp2  ; 
  wizfnloc wizptr  ; 
	;
#ifdef TRACE
  {
    (void) Fputs( logfile ,  "execute_fn `" ) ; 
  } 
  {
    outpoolstr ( logfile , hashtext [ exfnloc ] ) ; 
  } 
  {
    (void) fprintf( logfile , "%c\n",  '\'' ) ; 
  } 
#endif /* TRACE */
  switch ( ( fntype [ exfnloc ] ) ) 
  {case 0 : 
    {
	;
#ifdef STAT
      incr ( executioncount [ ilkinfo [ exfnloc ] ] ) ; 
#endif /* STAT */
      switch ( ( ilkinfo [ exfnloc ] ) ) 
      {case 0 : 
	xequals () ; 
	break ; 
      case 1 : 
	xgreaterthan () ; 
	break ; 
      case 2 : 
	xlessthan () ; 
	break ; 
      case 3 : 
	xplus () ; 
	break ; 
      case 4 : 
	xminus () ; 
	break ; 
      case 5 : 
	xconcatenate () ; 
	break ; 
      case 6 : 
	xgets () ; 
	break ; 
      case 7 : 
	xaddperiod () ; 
	break ; 
      case 8 : 
	{
	  if ( ( ! messwithentries ) ) 
	  bstcantmesswithentri () ; 
	  else if ( ( typelist [ citeptr ] == 5001 ) ) 
	  executefn ( bdefault ) ; 
	  else if ( ( typelist [ citeptr ] == 0 ) ) 
	  ; 
	  else executefn ( typelist [ citeptr ] ) ; 
	} 
	break ; 
      case 9 : 
	xchangecase () ; 
	break ; 
      case 10 : 
	xchrtoint () ; 
	break ; 
      case 11 : 
	xcite () ; 
	break ; 
      case 12 : 
	xduplicate () ; 
	break ; 
      case 13 : 
	xempty () ; 
	break ; 
      case 14 : 
	xformatname () ; 
	break ; 
      case 15 : 
	{
	  poplitstk ( poplit1 , poptyp1 ) ; 
	  poplitstk ( poplit2 , poptyp2 ) ; 
	  poplitstk ( poplit3 , poptyp3 ) ; 
	  if ( ( poptyp1 != 2 ) ) 
	  printwrongstklit ( poplit1 , poptyp1 , 2 ) ; 
	  else if ( ( poptyp2 != 2 ) ) 
	  printwrongstklit ( poplit2 , poptyp2 , 2 ) ; 
	  else if ( ( poptyp3 != 0 ) ) 
	  printwrongstklit ( poplit3 , poptyp3 , 0 ) ; 
	  else if ( ( poplit3 > 0 ) ) 
	  executefn ( poplit2 ) ; 
	  else executefn ( poplit1 ) ; 
	} 
	break ; 
      case 16 : 
	xinttochr () ; 
	break ; 
      case 17 : 
	xinttostr () ; 
	break ; 
      case 18 : 
	xmissing () ; 
	break ; 
      case 19 : 
	{
	  outputbblline () ; 
	} 
	break ; 
      case 20 : 
	xnumnames () ; 
	break ; 
      case 21 : 
	{
	  poplitstk ( poplit1 , poptyp1 ) ; 
	} 
	break ; 
      case 22 : 
	xpreamble () ; 
	break ; 
      case 23 : 
	xpurify () ; 
	break ; 
      case 24 : 
	xquote () ; 
	break ; 
      case 25 : 
	{
	  ; 
	} 
	break ; 
      case 26 : 
	{
	  popwholestack () ; 
	} 
	break ; 
      case 27 : 
	xsubstring () ; 
	break ; 
      case 28 : 
	xswap () ; 
	break ; 
      case 29 : 
	xtextlength () ; 
	break ; 
      case 30 : 
	xtextprefix () ; 
	break ; 
      case 31 : 
	{
	  poptopandprint () ; 
	} 
	break ; 
      case 32 : 
	xtype () ; 
	break ; 
      case 33 : 
	xwarning () ; 
	break ; 
      case 34 : 
	{
	  poplitstk ( rpoplt1 , rpoptp1 ) ; 
	  poplitstk ( rpoplt2 , rpoptp2 ) ; 
	  if ( ( rpoptp1 != 2 ) ) 
	  printwrongstklit ( rpoplt1 , rpoptp1 , 2 ) ; 
	  else if ( ( rpoptp2 != 2 ) ) 
	  printwrongstklit ( rpoplt2 , rpoptp2 , 2 ) ; 
	  else while ( true ) {
	      
	    executefn ( rpoplt2 ) ; 
	    poplitstk ( poplit1 , poptyp1 ) ; 
	    if ( ( poptyp1 != 0 ) ) 
	    {
	      printwrongstklit ( poplit1 , poptyp1 , 0 ) ; 
	      goto lab51 ; 
	    } 
	    else if ( ( poplit1 > 0 ) ) 
	    executefn ( rpoplt1 ) ; 
	    else goto lab51 ; 
	  } 
	  lab51: ; 
	} 
	break ; 
      case 35 : 
	xwidth () ; 
	break ; 
      case 36 : 
	xwrite () ; 
	break ; 
	default: 
	{
	  {
	    (void) Fputs( logfile ,  "Unknown built-in function" ) ; 
	    (void) Fputs( stdout ,  "Unknown built-in function" ) ; 
	  } 
	  printconfusion () ; 
	  longjmp(jmp9998,1) ; 
	} 
	break ; 
      } 
    } 
    break ; 
  case 1 : 
    {
      wizptr = ilkinfo [ exfnloc ] ; 
      while ( ( wizfunctions [ wizptr ] != 5001 ) ) {
	  
	if ( ( wizfunctions [ wizptr ] != 0 ) ) 
	executefn ( wizfunctions [ wizptr ] ) ; 
	else {
	    
	  incr ( wizptr ) ; 
	  pushlitstk ( wizfunctions [ wizptr ] , 2 ) ; 
	} 
	incr ( wizptr ) ; 
      } 
    } 
    break ; 
  case 2 : 
    pushlitstk ( ilkinfo [ exfnloc ] , 0 ) ; 
    break ; 
  case 3 : 
    pushlitstk ( hashtext [ exfnloc ] , 1 ) ; 
    break ; 
  case 4 : 
    {
      if ( ( ! messwithentries ) ) 
      bstcantmesswithentri () ; 
      else {
	  
	fieldptr = citeptr * numfields + ilkinfo [ exfnloc ] ; 
	if ( ( fieldinfo [ fieldptr ] == 0 ) ) 
	pushlitstk ( hashtext [ exfnloc ] , 3 ) ; 
	else pushlitstk ( fieldinfo [ fieldptr ] , 1 ) ; 
      } 
    } 
    break ; 
  case 5 : 
    {
      if ( ( ! messwithentries ) ) 
      bstcantmesswithentri () ; 
      else pushlitstk ( entryints [ citeptr * numentints + ilkinfo [ exfnloc ] 
      ] , 0 ) ; 
    } 
    break ; 
  case 6 : 
    {
      if ( ( ! messwithentries ) ) 
      bstcantmesswithentri () ; 
      else {
	  
	strentptr = citeptr * numentstrs + ilkinfo [ exfnloc ] ; 
	exbufptr = 0 ; 
	while ( ( entrystrs [ strentptr ] [ exbufptr ] != 127 ) ) {
	    
	  exbuf [ exbufptr ] = entrystrs [ strentptr ] [ exbufptr ] ; 
	  incr ( exbufptr ) ; 
	} 
	exbuflength = exbufptr ; 
	addpoolbufandpush () ; 
      } 
    } 
    break ; 
  case 7 : 
    pushlitstk ( ilkinfo [ exfnloc ] , 0 ) ; 
    break ; 
  case 8 : 
    {
      strglbptr = ilkinfo [ exfnloc ] ; 
      if ( ( glbstrptr [ strglbptr ] > 0 ) ) 
      pushlitstk ( glbstrptr [ strglbptr ] , 1 ) ; 
      else {
	  
	{
	  if ( ( poolptr + glbstrend [ strglbptr ] > poolsize ) ) 
	  pooloverflow () ; 
	} 
	globchrptr = 0 ; 
	while ( ( globchrptr < glbstrend [ strglbptr ] ) ) {
	    
	  {
	    strpool [ poolptr ] = globalstrs [ strglbptr ] [ globchrptr ] ; 
	    incr ( poolptr ) ; 
	  } 
	  incr ( globchrptr ) ; 
	} 
	pushlitstk ( makestring () , 1 ) ; 
      } 
    } 
    break ; 
    default: 
    unknwnfunctionclassc () ; 
    break ; 
  } 
} 
getthetoplevelauxfil () {
    /* 41 46 */ while ( true ) { 
    if ( ( gargc > 1 ) ) 
    auxnamelength = getcmdline ( nameoffile , 1024 ) ; 
    else {
	
      (void) Fputs( stdout ,  "Please type input file name (no extension)--" ) ; 
      auxnamelength = 0 ; 
      while ( ( ! eoln ( stdin ) ) ) {
	  
	if ( ( auxnamelength == 1024 ) ) 
	{
	  readln ( stdin ) ; 
	  {
	    samtoolongfilenamepr () ; 
	    goto lab46 ; 
	  } 
	} 
	nameoffile [ auxnamelength ] = getc ( stdin ) ; 
	incr ( auxnamelength ) ; 
      } 
    } 
    {
      if ( ( ( auxnamelength + ( strstart [ sauxextension + 1 ] - strstart [ 
      sauxextension ] ) > 1024 ) || ( auxnamelength + ( strstart [ 
      slogextension + 1 ] - strstart [ slogextension ] ) > 1024 ) || ( 
      auxnamelength + ( strstart [ sbblextension + 1 ] - strstart [ 
      sbblextension ] ) > 1024 ) ) ) 
      {
	samtoolongfilenamepr () ; 
	goto lab46 ; 
      } 
      {
	namelength = auxnamelength ; 
	addextension ( sauxextension ) ;  
	auxptr = 0 ; 
	if ( ( ! aopenin ( auxfile [ auxptr ] ) ) ) 
	{
	  samwrongfilenameprin () ; 
	  goto lab46 ; 
	} 
	namelength = auxnamelength ; 
	addextension ( slogextension ) ; 
	if ( ( ! aopenout ( logfile ) ) ) 
	{
	  samwrongfilenameprin () ; 
	  goto lab46 ; 
	} 
	namelength = auxnamelength ; 
	addextension ( sbblextension ) ; 
	if ( ( ! aopenout ( bblfile ) ) ) 
	{
	  samwrongfilenameprin () ; 
	  goto lab46 ; 
	} 
      } 
      {
	namelength = auxnamelength ; 
	addextension ( sauxextension ) ; 
	nameptr = 1 ; 
	while ( ( nameptr <= namelength ) ) {
	    
	  buffer [ nameptr ] = xord [ nameoffile [ nameptr - 1 ] ] ; 
	  incr ( nameptr ) ; 
	} 
	toplevstr = hashtext [ strlookup ( buffer , 1 , auxnamelength , 0 , 
	true ) ] ; 
	auxlist [ auxptr ] = hashtext [ strlookup ( buffer , 1 , namelength , 
	3 , true ) ] ; 
	if ( ( hashfound ) ) 
	{
	;
#ifdef TRACE
	  printauxname () ; 
#endif /* TRACE */
	  {
	    {
	      (void) Fputs( logfile ,  "Already encountered auxiliary file" ) ; 
	      (void) Fputs( stdout ,  "Already encountered auxiliary file" ) ; 
	    } 
	    printconfusion () ; 
	    longjmp(jmp9998,1) ; 
	  } 
	} 
	auxlnstack [ auxptr ] = 0 ; 
      } 
      goto lab41 ; 
    } 
    lab46: gargc = 0 ; 
  } 
  lab41: ; 
} 
auxbibdatacommand () {
    /* 10 */ if ( ( bibseen ) ) 
  {
    auxerrillegalanother ( 0 ) ; 
    {
      auxerrprint () ; 
      goto lab10 ; 
    } 
  } 
  bibseen = true ; 
  while ( ( buffer [ bufptr2 ] != 125 ) ) {
      
    incr ( bufptr2 ) ; 
    if ( ( ! scan2white ( 125 , 44 ) ) ) 
    {
      auxerrnorightbracepr () ; 
      {
	auxerrprint () ; 
	goto lab10 ; 
      } 
    } 
    if ( ( lexclass [ buffer [ bufptr2 ] ] == 1 ) ) 
    {
      auxerrwhitespaceinar () ; 
      {
	auxerrprint () ; 
	goto lab10 ; 
      } 
    } 
    if ( ( ( last > bufptr2 + 1 ) && ( buffer [ bufptr2 ] == 125 ) ) ) 
    {
      auxerrstuffafterrigh () ; 
      {
	auxerrprint () ; 
	goto lab10 ; 
      } 
    } 
    {
      if ( ( bibptr == maxbibfiles ) ) 
      {
	printoverflow () ; 
	{
	  (void) fprintf( logfile , "%s%ld\n",  "number of database files " , (long)maxbibfiles ) ; 
	  (void) fprintf( stdout , "%s%ld\n",  "number of database files " , (long)maxbibfiles ) ; 
	} 
	longjmp(jmp9998,1) ; 
      } 
      biblist [ bibptr ] = hashtext [ strlookup ( buffer , bufptr1 , ( bufptr2 
      - bufptr1 ) , 6 , true ) ] ; 
      if ( ( hashfound ) ) 
      {
	{
	  (void) Fputs( logfile ,  "This database file appears more than once: " ) ; 
	  (void) Fputs( stdout ,  "This database file appears more than once: " ) ; 
	} 
	printbibname () ; 
	{
	  auxerrprint () ; 
	  goto lab10 ; 
	} 
      } 
      startname ( biblist [ bibptr ] ) ; 
      addextension ( sbibextension ) ; 
      if ( ( ! aopenin ( bibfile [ bibptr ] ) ) ) 
      {
	addarea ( sbibarea ) ; 
	if ( ( ! aopenin ( bibfile [ bibptr ] ) ) ) 
	{
	  {
	    (void) Fputs( logfile ,  "I couldn't open database file " ) ; 
	    (void) Fputs( stdout ,  "I couldn't open database file " ) ; 
	  } 
	  printbibname () ; 
	  {
	    auxerrprint () ; 
	    goto lab10 ; 
	  } 
	} 
      } 
	;
#ifdef TRACE
      {
	outpoolstr ( logfile , biblist [ bibptr ] ) ; 
      } 
      {
	outpoolstr ( logfile , sbibextension ) ; 
      } 
      {
	(void) fprintf( logfile , "%s\n",  " is a bibdata file" ) ; 
      } 
#endif /* TRACE */
      incr ( bibptr ) ; 
    } 
  } 
  lab10: ; 
} 
auxbibstylecommand () {
    /* 10 */ if ( ( bstseen ) ) 
  {
    auxerrillegalanother ( 1 ) ; 
    {
      auxerrprint () ; 
      goto lab10 ; 
    } 
  } 
  bstseen = true ; 
  incr ( bufptr2 ) ; 
  if ( ( ! scan1white ( 125 ) ) ) 
  {
    auxerrnorightbracepr () ; 
    {
      auxerrprint () ; 
      goto lab10 ; 
    } 
  } 
  if ( ( lexclass [ buffer [ bufptr2 ] ] == 1 ) ) 
  {
    auxerrwhitespaceinar () ; 
    {
      auxerrprint () ; 
      goto lab10 ; 
    } 
  } 
  if ( ( last > bufptr2 + 1 ) ) 
  {
    auxerrstuffafterrigh () ; 
    {
      auxerrprint () ; 
      goto lab10 ; 
    } 
  } 
  {
    bststr = hashtext [ strlookup ( buffer , bufptr1 , ( bufptr2 - bufptr1 ) , 
    5 , true ) ] ; 
    if ( ( hashfound ) ) 
    {
	;
#ifdef TRACE
      printbstname () ; 
#endif /* TRACE */
      {
	{
	  (void) Fputs( logfile ,  "Already encountered style file" ) ; 
	  (void) Fputs( stdout ,  "Already encountered style file" ) ; 
	} 
	printconfusion () ; 
	longjmp(jmp9998,1) ; 
      } 
    } 
    startname ( bststr ) ; 
    addextension ( sbstextension ) ; 
    if ( ( ! aopenin ( bstfile ) ) ) 
    {
      addarea ( sbstarea ) ; 
      if ( ( ! aopenin ( bstfile ) ) ) 
      {
	{
	  (void) Fputs( logfile ,  "I couldn't open style file " ) ; 
	  (void) Fputs( stdout ,  "I couldn't open style file " ) ; 
	} 
	printbstname () ; 
	bststr = 0 ; 
	{
	  auxerrprint () ; 
	  goto lab10 ; 
	} 
      } 
    } 
    {
      (void) Fputs( logfile ,  "The style file: " ) ; 
      (void) Fputs( stdout ,  "The style file: " ) ; 
    } 
    printbstname () ; 
  } 
  lab10: ; 
} 
auxcitationcommand () {
    /* 23 10 */ citationseen = true ; 
  while ( ( buffer [ bufptr2 ] != 125 ) ) {
      
    incr ( bufptr2 ) ; 
    if ( ( ! scan2white ( 125 , 44 ) ) ) 
    {
      auxerrnorightbracepr () ; 
      {
	auxerrprint () ; 
	goto lab10 ; 
      } 
    } 
    if ( ( lexclass [ buffer [ bufptr2 ] ] == 1 ) ) 
    {
      auxerrwhitespaceinar () ; 
      {
	auxerrprint () ; 
	goto lab10 ; 
      } 
    } 
    if ( ( ( last > bufptr2 + 1 ) && ( buffer [ bufptr2 ] == 125 ) ) ) 
    {
      auxerrstuffafterrigh () ; 
      {
	auxerrprint () ; 
	goto lab10 ; 
      } 
    } 
    {
	;
#ifdef TRACE
      {
	outtoken ( logfile ) ; 
      } 
      {
	(void) Fputs( logfile ,  " cite key encountered" ) ; 
      } 
#endif /* TRACE */
      {
	if ( ( ( bufptr2 - bufptr1 ) == 1 ) ) 
	if ( ( buffer [ bufptr1 ] == 42 ) ) 
	{
	;
#ifdef TRACE
	  {
	    (void) fprintf( logfile , "%s\n",  "---entire database to be included" ) ; 
	  } 
#endif /* TRACE */
	  if ( ( allentries ) ) 
	  {
	    {
	      (void) fprintf( logfile , "%s\n",  "Multiple inclusions of entire database" ) ; 
	      (void) fprintf( stdout , "%s\n",  "Multiple inclusions of entire database" ) ; 
	    } 
	    {
	      auxerrprint () ; 
	      goto lab10 ; 
	    } 
	  } 
	  else {
	      
	    allentries = true ; 
	    allmarker = citeptr ; 
	    goto lab23 ; 
	  } 
	} 
      } 
      tmpptr = bufptr1 ; 
      while ( ( tmpptr < bufptr2 ) ) {
	  
	exbuf [ tmpptr ] = buffer [ tmpptr ] ; 
	incr ( tmpptr ) ; 
      } 
      lowercase ( exbuf , bufptr1 , ( bufptr2 - bufptr1 ) ) ; 
      lcciteloc = strlookup ( exbuf , bufptr1 , ( bufptr2 - bufptr1 ) , 10 , 
      true ) ; 
      if ( ( hashfound ) ) 
      {
	;
#ifdef TRACE
	{
	  (void) fprintf( logfile , "%s\n",  " previously" ) ; 
	} 
#endif /* TRACE */
	dummyloc = strlookup ( buffer , bufptr1 , ( bufptr2 - bufptr1 ) , 9 , 
	false ) ; 
	if ( ( ! hashfound ) ) 
	{
	  {
	    (void) Fputs( logfile ,  "Case mismatch error between cite keys " ) ; 
	    (void) Fputs( stdout ,  "Case mismatch error between cite keys " ) ; 
	  } 
	  printatoken () ; 
	  {
	    (void) Fputs( logfile ,  " and " ) ; 
	    (void) Fputs( stdout ,  " and " ) ; 
	  } 
	  printapoolstr ( citelist [ ilkinfo [ ilkinfo [ lcciteloc ] ] ] ) ; 
	  printanewline () ; 
	  {
	    auxerrprint () ; 
	    goto lab10 ; 
	  } 
	} 
      } 
      else {
	  
	;
#ifdef TRACE
	{
	  (void) putc('\n',  logfile );
	} 
#endif /* TRACE */
	citeloc = strlookup ( buffer , bufptr1 , ( bufptr2 - bufptr1 ) , 9 , 
	true ) ; 
	if ( ( hashfound ) ) 
	hashciteconfusion () ; 
	checkciteoverflow ( citeptr ) ; 
	citelist [ citeptr ] = hashtext [ citeloc ] ; 
	ilkinfo [ citeloc ] = citeptr ; 
	ilkinfo [ lcciteloc ] = citeloc ; 
	incr ( citeptr ) ; 
      } 
    } 
    lab23: ; 
  } 
  lab10: ; 
} 
auxinputcommand () {
    /* 10 */ boolean auxextensionok  ; 
  incr ( bufptr2 ) ; 
  if ( ( ! scan1white ( 125 ) ) ) 
  {
    auxerrnorightbracepr () ; 
    {
      auxerrprint () ; 
      goto lab10 ; 
    } 
  } 
  if ( ( lexclass [ buffer [ bufptr2 ] ] == 1 ) ) 
  {
    auxerrwhitespaceinar () ; 
    {
      auxerrprint () ; 
      goto lab10 ; 
    } 
  } 
  if ( ( last > bufptr2 + 1 ) ) 
  {
    auxerrstuffafterrigh () ; 
    {
      auxerrprint () ; 
      goto lab10 ; 
    } 
  } 
  {
    incr ( auxptr ) ; 
    if ( ( auxptr == auxstacksize ) ) 
    {
      printatoken () ; 
      {
	(void) Fputs( logfile ,  ": " ) ; 
	(void) Fputs( stdout ,  ": " ) ; 
      } 
      {
	printoverflow () ; 
	{
	  (void) fprintf( logfile , "%s%ld\n",  "auxiliary file depth " , (long)auxstacksize ) ; 
	  (void) fprintf( stdout , "%s%ld\n",  "auxiliary file depth " , (long)auxstacksize ) ; 
	} 
	longjmp(jmp9998,1) ; 
      } 
    } 
    auxextensionok = true ; 
    if ( ( ( bufptr2 - bufptr1 ) < ( strstart [ sauxextension + 1 ] - strstart 
    [ sauxextension ] ) ) ) 
    auxextensionok = false ; 
    else if ( ( ! streqbuf ( sauxextension , buffer , bufptr2 - ( strstart [ 
    sauxextension + 1 ] - strstart [ sauxextension ] ) , ( strstart [ 
    sauxextension + 1 ] - strstart [ sauxextension ] ) ) ) ) 
    auxextensionok = false ; 
    if ( ( ! auxextensionok ) ) 
    {
      printatoken () ; 
      {
	(void) Fputs( logfile ,  " has a wrong extension" ) ; 
	(void) Fputs( stdout ,  " has a wrong extension" ) ; 
      } 
      decr ( auxptr ) ; 
      {
	auxerrprint () ; 
	goto lab10 ; 
      } 
    } 
    auxlist [ auxptr ] = hashtext [ strlookup ( buffer , bufptr1 , ( bufptr2 - 
    bufptr1 ) , 3 , true ) ] ; 
    if ( ( hashfound ) ) 
    {
      {
	(void) Fputs( logfile ,  "Already encountered file " ) ; 
	(void) Fputs( stdout ,  "Already encountered file " ) ; 
      } 
      printauxname () ; 
      decr ( auxptr ) ; 
      {
	auxerrprint () ; 
	goto lab10 ; 
      } 
    } 
    {
      startname ( auxlist [ auxptr ] ) ; 
      nameptr = namelength ; 
      while ( ( nameptr <= 1024 ) ) {
	  
	nameoffile [ nameptr ] = ' ' ; 
	incr ( nameptr ) ; 
      } 
      if ( ( ! aopenin ( auxfile [ auxptr ] ) ) ) 
      {
	{
	  (void) Fputs( logfile ,  "I couldn't open auxiliary file " ) ; 
	  (void) Fputs( stdout ,  "I couldn't open auxiliary file " ) ; 
	} 
	printauxname () ; 
	decr ( auxptr ) ; 
	{
	  auxerrprint () ; 
	  goto lab10 ; 
	} 
      } 
      {
	(void) fprintf( logfile , "%s%ld%s",  "A level-" , (long)auxptr , " auxiliary file: " ) ; 
	(void) fprintf( stdout , "%s%ld%s",  "A level-" , (long)auxptr , " auxiliary file: " ) ; 
      } 
      printauxname () ; 
      auxlnstack [ auxptr ] = 0 ; 
    } 
  } 
  lab10: ; 
} 
poptheauxstack () {
    aclose ( auxfile [ auxptr ] ) ; 
  if ( ( auxptr == 0 ) ) 
  {lab31=1; return;}
  else decr ( auxptr ) ; 
} 
getauxcommandandproc () {
    /* 10 */ bufptr2 = 0 ; 
  if ( ( ! scan1 ( 123 ) ) ) 
  goto lab10 ; 
  commandnum = ilkinfo [ strlookup ( buffer , bufptr1 , ( bufptr2 - bufptr1 ) 
  , 2 , false ) ] ; 
  if ( ( hashfound ) ) 
  switch ( ( commandnum ) ) 
  {case 0 : 
    auxbibdatacommand () ; 
    break ; 
  case 1 : 
    auxbibstylecommand () ; 
    break ; 
  case 2 : 
    auxcitationcommand () ; 
    break ; 
  case 3 : 
    auxinputcommand () ; 
    break ; 
    default: 
    {
      {
	(void) Fputs( logfile ,  "Unknown auxiliary-file command" ) ; 
	(void) Fputs( stdout ,  "Unknown auxiliary-file command" ) ; 
      } 
      printconfusion () ; 
      longjmp(jmp9998,1) ; 
    } 
    break ; 
  } 
  lab10: ; 
} 
lastcheckforauxerror () {
    numcites = citeptr ; 
  numbibfiles = bibptr ; 
  if ( ( ! citationseen ) ) 
  {
    auxend1errprint () ; 
    {
      (void) Fputs( logfile ,  "\\citation commands" ) ; 
      (void) Fputs( stdout ,  "\\citation commands" ) ; 
    } 
    auxend2errprint () ; 
  } 
  else if ( ( ( numcites == 0 ) && ( ! allentries ) ) ) 
  {
    auxend1errprint () ; 
    {
      (void) Fputs( logfile ,  "cite keys" ) ; 
      (void) Fputs( stdout ,  "cite keys" ) ; 
    } 
    auxend2errprint () ; 
  } 
  if ( ( ! bibseen ) ) 
  {
    auxend1errprint () ; 
    {
      (void) Fputs( logfile ,  "\\bibdata command" ) ; 
      (void) Fputs( stdout ,  "\\bibdata command" ) ; 
    } 
    auxend2errprint () ; 
  } 
  else if ( ( numbibfiles == 0 ) ) 
  {
    auxend1errprint () ; 
    {
      (void) Fputs( logfile ,  "database files" ) ; 
      (void) Fputs( stdout ,  "database files" ) ; 
    } 
    auxend2errprint () ; 
  } 
  if ( ( ! bstseen ) ) 
  {
    auxend1errprint () ; 
    {
      (void) Fputs( logfile ,  "\\bibstyle command" ) ; 
      (void) Fputs( stdout ,  "\\bibstyle command" ) ; 
    } 
    auxend2errprint () ; 
  } 
  else if ( ( bststr == 0 ) ) 
  {
    auxend1errprint () ; 
    {
      (void) Fputs( logfile ,  "style file" ) ; 
      (void) Fputs( stdout ,  "style file" ) ; 
    } 
    auxend2errprint () ; 
  } 
} 
