#include "bibtex.h"
#include "bibtex.p"
#include "globals.h"
#include "coerce.h"

bibidprint () {
    if ( ( scanresult == 0 ) ) 
  {
    (void) Fputs( logfile ,  "You're missing " ) ; 
    (void) Fputs( stdout ,  "You're missing " ) ; 
  } 
  else if ( ( scanresult == 2 ) ) 
  {
    (void) fprintf( logfile , "%c%c%s",  '"' , xchr [ buffer [ bufptr2 ] ] ,     "\" immediately follows " ) ; 
    (void) fprintf( stdout , "%c%c%s",  '"' , xchr [ buffer [ bufptr2 ] ] ,     "\" immediately follows " ) ; 
  } 
  else idscanningconfusion () ; 
} 
bibcmdconfusion () {
    { 
    {
      (void) Fputs( logfile ,  "Unknown database-file command" ) ; 
      (void) Fputs( stdout ,  "Unknown database-file command" ) ; 
    } 
    printconfusion () ; 
    longjmp(jmp9998,1) ; 
  } 
} 
citekeydisappearedco () {
    { 
    {
      (void) Fputs( logfile ,  "A cite key disappeared" ) ; 
      (void) Fputs( stdout ,  "A cite key disappeared" ) ; 
    } 
    printconfusion () ; 
    longjmp(jmp9998,1) ; 
  } 
} 
zbadcrossreferencepri ( s ) 
strnumber s ; 
{{
    
    (void) Fputs( logfile ,  "--entry \"" ) ; 
    (void) Fputs( stdout ,  "--entry \"" ) ; 
  } 
  printapoolstr ( citelist [ citeptr ] ) ; 
  {
    (void) fprintf( logfile , "%c\n",  '"' ) ; 
    (void) fprintf( stdout , "%c\n",  '"' ) ; 
  } 
  {
    (void) Fputs( logfile ,  "refers to entry \"" ) ; 
    (void) Fputs( stdout ,  "refers to entry \"" ) ; 
  } 
  printapoolstr ( s ) ; 
} 
nonexistentcrossrefe () {
    { 
    (void) Fputs( logfile ,  "A bad cross reference-" ) ; 
    (void) Fputs( stdout ,  "A bad cross reference-" ) ; 
  } 
  badcrossreferencepri ( fieldinfo [ fieldptr ] ) ; 
  {
    (void) fprintf( logfile , "%s%ld\n",  "\", (long)which doesn't exist" ) ; 
    (void) fprintf( stdout , "%s%ld\n",  "\", (long)which doesn't exist" ) ; 
  } 
  markerror () ; 
} 
zprintmissingentry ( s ) 
strnumber s ; 
{{
    
    (void) Fputs( logfile ,  "Warning--I didn't find a database entry for \"" ) ; 
    (void) Fputs( stdout ,  "Warning--I didn't find a database entry for \"" ) ; 
  } 
  printapoolstr ( s ) ; 
  {
    (void) fprintf( logfile , "%c\n",  '"' ) ; 
    (void) fprintf( stdout , "%c\n",  '"' ) ; 
  } 
  markwarning () ; 
} 
bstexwarnprint () {
    if ( ( messwithentries ) ) 
  {
    {
      (void) Fputs( logfile ,  " for entry " ) ; 
      (void) Fputs( stdout ,  " for entry " ) ; 
    } 
    printapoolstr ( citelist [ citeptr ] ) ; 
  } 
  printanewline () ; 
  {
    (void) Fputs( logfile ,  "while executing-" ) ; 
    (void) Fputs( stdout ,  "while executing-" ) ; 
  } 
  bstlnnumprint () ; 
  markerror () ; 
} 
bstmildexwarnprint () {
    if ( ( messwithentries ) ) 
  {
    {
      (void) Fputs( logfile ,  " for entry " ) ; 
      (void) Fputs( stdout ,  " for entry " ) ; 
    } 
    printapoolstr ( citelist [ citeptr ] ) ; 
  } 
  printanewline () ; 
  {
    {
      (void) Fputs( logfile ,  "while executing" ) ; 
      (void) Fputs( stdout ,  "while executing" ) ; 
    } 
    bstwarnprint () ; 
  } 
} 
bstcantmesswithentri () {
    { 
    {
      (void) Fputs( logfile ,  "You can't mess with entries here" ) ; 
      (void) Fputs( stdout ,  "You can't mess with entries here" ) ; 
    } 
    bstexwarnprint () ; 
  } 
} 
illeglliteralconfusi () {
    { 
    {
      (void) Fputs( logfile ,  "Illegal literal type" ) ; 
      (void) Fputs( stdout ,  "Illegal literal type" ) ; 
    } 
    printconfusion () ; 
    longjmp(jmp9998,1) ; 
  } 
} 
unknwnliteralconfusi () {
    { 
    {
      (void) Fputs( logfile ,  "Unknown literal type" ) ; 
      (void) Fputs( stdout ,  "Unknown literal type" ) ; 
    } 
    printconfusion () ; 
    longjmp(jmp9998,1) ; 
  } 
} 
zprintstklit ( stklt , stktp ) 
integer stklt ; 
stktype stktp ; 
{switch ( ( stktp ) ) 
  {case 0 : 
    {
      (void) fprintf( logfile , "%ld%s",  (long)stklt , " is an integer literal" ) ; 
      (void) fprintf( stdout , "%ld%s",  (long)stklt , " is an integer literal" ) ; 
    } 
    break ; 
  case 1 : 
    {
      {
	(void) putc( '"' ,  logfile );
	(void) putc( '"' ,  stdout );
      } 
      printapoolstr ( stklt ) ; 
      {
	(void) Fputs( logfile ,  "\" is a string literal" ) ; 
	(void) Fputs( stdout ,  "\" is a string literal" ) ; 
      } 
    } 
    break ; 
  case 2 : 
    {
      {
	(void) putc( '`' ,  logfile );
	(void) putc( '`' ,  stdout );
      } 
      printapoolstr ( hashtext [ stklt ] ) ; 
      {
	(void) Fputs( logfile ,  "' is a function literal" ) ; 
	(void) Fputs( stdout ,  "' is a function literal" ) ; 
      } 
    } 
    break ; 
  case 3 : 
    {
      {
	(void) putc( '`' ,  logfile );
	(void) putc( '`' ,  stdout );
      } 
      printapoolstr ( stklt ) ; 
      {
	(void) Fputs( logfile ,  "' is a missing field" ) ; 
	(void) Fputs( stdout ,  "' is a missing field" ) ; 
      } 
    } 
    break ; 
  case 4 : 
    illeglliteralconfusi () ; 
    break ; 
    default: 
    unknwnliteralconfusi () ; 
    break ; 
  } 
} 
zprintlit ( stklt , stktp ) 
integer stklt ; 
stktype stktp ; 
{switch ( ( stktp ) ) 
  {case 0 : 
    {
      (void) fprintf( logfile , "%ld\n",  (long)stklt ) ; 
      (void) fprintf( stdout , "%ld\n",  (long)stklt ) ; 
    } 
    break ; 
  case 1 : 
    {
      printapoolstr ( stklt ) ; 
      printanewline () ; 
    } 
    break ; 
  case 2 : 
    {
      printapoolstr ( hashtext [ stklt ] ) ; 
      printanewline () ; 
    } 
    break ; 
  case 3 : 
    {
      printapoolstr ( stklt ) ; 
      printanewline () ; 
    } 
    break ; 
  case 4 : 
    illeglliteralconfusi () ; 
    break ; 
    default: 
    unknwnliteralconfusi () ; 
    break ; 
  } 
} 
outputbblline () {
    /* 15 10 */ if ( ( outbuflength != 0 ) ) 
  {
    while ( ( outbuflength > 0 ) ) if ( ( lexclass [ outbuf [ outbuflength - 1 
    ] ] == 1 ) ) 
    decr ( outbuflength ) ; 
    else goto lab15 ; 
    lab15: if ( ( outbuflength == 0 ) ) 
    goto lab10 ; 
    outbufptr = 0 ; 
    while ( ( outbufptr < outbuflength ) ) {
	
      (void) putc( xchr [ outbuf [ outbufptr ] ] ,  bblfile );
      incr ( outbufptr ) ; 
    } 
  } 
  (void) putc('\n',  bblfile );
  incr ( bbllinenum ) ; 
  outbuflength = 0 ; 
  lab10: ; 
} 
bst1printstringsizee () {
    { 
    (void) Fputs( logfile ,  "Warning--you've exceeded " ) ; 
    (void) Fputs( stdout ,  "Warning--you've exceeded " ) ; 
  } 
} 
bst2printstringsizee () {
    { 
    (void) Fputs( logfile ,  "-string-size," ) ; 
    (void) Fputs( stdout ,  "-string-size," ) ; 
  } 
  bstmildexwarnprint () ; 
  {
    (void) fprintf( logfile , "%s\n",  "*Please notify the bibstyle designer*" ) ; 
    (void) fprintf( stdout , "%s\n",  "*Please notify the bibstyle designer*" ) ; 
  } 
} 
zbracesunbalancedcomp ( poplitvar ) 
strnumber poplitvar ; 
{{
    
    (void) Fputs( logfile ,  "Warning--\"" ) ; 
    (void) Fputs( stdout ,  "Warning--\"" ) ; 
  } 
  printapoolstr ( poplitvar ) ; 
  {
    {
      (void) Fputs( logfile ,  "\" isn't a brace-balanced string" ) ; 
      (void) Fputs( stdout ,  "\" isn't a brace-balanced string" ) ; 
    } 
    bstmildexwarnprint () ; 
  } 
} 
caseconversionconfus () {
    { 
    {
      (void) Fputs( logfile ,  "Unknown type of case conversion" ) ; 
      (void) Fputs( stdout ,  "Unknown type of case conversion" ) ; 
    } 
    printconfusion () ; 
    longjmp(jmp9998,1) ; 
  } 
} 
traceandstatprinting () {
    
	;
#ifdef TRACE
  {
    if ( ( numbibfiles == 1 ) ) 
    {
      (void) fprintf( logfile , "%s\n",  "The 1 database file is" ) ; 
    } 
    else {
	
      (void) fprintf( logfile , "%s%ld%s\n",  "The " , (long)numbibfiles , " database files are" ) ; 
    } 
    if ( ( numbibfiles == 0 ) ) 
    {
      (void) fprintf( logfile , "%s\n",  "   undefined" ) ; 
    } 
    else {
	
      bibptr = 0 ; 
      while ( ( bibptr < numbibfiles ) ) {
	  
	{
	  (void) Fputs( logfile ,  "   " ) ; 
	} 
	{
	  outpoolstr ( logfile , biblist [ bibptr ] ) ; 
	} 
	{
	  outpoolstr ( logfile , sbibextension ) ; 
	} 
	{
	  (void) putc('\n',  logfile );
	} 
	incr ( bibptr ) ; 
      } 
    } 
    {
      (void) Fputs( logfile ,  "The style file is " ) ; 
    } 
    if ( ( bststr == 0 ) ) 
    {
      (void) fprintf( logfile , "%s\n",  "undefined" ) ; 
    } 
    else {
	
      {
	outpoolstr ( logfile , bststr ) ; 
      } 
      {
	outpoolstr ( logfile , sbstextension ) ; 
      } 
      {
	(void) putc('\n',  logfile );
      } 
    } 
  } 
  {
    if ( ( allentries ) ) 
    {
      (void) fprintf( logfile , "%s%ld%s",  "all_marker=" , (long)allmarker , ", " ) ; 
    } 
    if ( ( readperformed ) ) 
    {
      (void) fprintf( logfile , "%s%ld\n",  "old_num_cites=" , (long)oldnumcites ) ; 
    } 
    else {
	
      (void) putc('\n',  logfile );
    } 
    {
      (void) fprintf( logfile , "%s%ld",  "The " , (long)numcites ) ; 
    } 
    if ( ( numcites == 1 ) ) 
    {
      (void) fprintf( logfile , "%s\n",  " entry:" ) ; 
    } 
    else {
	
      (void) fprintf( logfile , "%s\n",  " entries:" ) ; 
    } 
    if ( ( numcites == 0 ) ) 
    {
      (void) fprintf( logfile , "%s\n",  "   undefined" ) ; 
    } 
    else {
	
      sortciteptr = 0 ; 
      while ( ( sortciteptr < numcites ) ) {
	  
	if ( ( ! readcompleted ) ) 
	citeptr = sortciteptr ; 
	else citeptr = citeinfo [ sortciteptr ] ; 
	{
	  outpoolstr ( logfile , citelist [ citeptr ] ) ; 
	} 
	if ( ( readperformed ) ) 
	{
	  {
	    (void) Fputs( logfile ,  ", entry-type " ) ; 
	  } 
	  if ( ( typelist [ citeptr ] == 5001 ) ) 
	  lab5001: {
	      
	    (void) Fputs( logfile ,  "unknown" ) ; 
	  } 
	  else if ( ( typelist [ citeptr ] == 0 ) ) 
	  {
	    (void) Fputs( logfile ,  "--- no type found" ) ; 
	  } 
	  else {
	      
	    outpoolstr ( logfile , hashtext [ typelist [ citeptr ] ] ) ; 
	  } 
	  {
	    (void) fprintf( logfile , "%s\n",  ", has entry strings" ) ; 
	  } 
	  {
	    if ( ( numentstrs == 0 ) ) 
	    {
	      (void) fprintf( logfile , "%s\n",  "    undefined" ) ; 
	    } 
	    else if ( ( ! readcompleted ) ) 
	    {
	      (void) fprintf( logfile , "%s\n",  "    uninitialized" ) ; 
	    } 
	    else {
		
	      strentptr = citeptr * numentstrs ; 
	      while ( ( strentptr < ( citeptr + 1 ) * numentstrs ) ) {
		  
		entchrptr = 0 ; 
		{
		  (void) Fputs( logfile ,  "    \"" ) ; 
		} 
		while ( ( entrystrs [ strentptr ] [ entchrptr ] != 127 ) ) {
		    
		  {
		    (void) putc( xchr [ entrystrs [ strentptr ] [                     entchrptr ] ] ,  logfile );
		  } 
		  incr ( entchrptr ) ; 
		} 
		{
		  (void) fprintf( logfile , "%c\n",  '"' ) ; 
		} 
		incr ( strentptr ) ; 
	      } 
	    } 
	  } 
	  {
	    (void) Fputs( logfile ,  "  has entry integers" ) ; 
	  } 
	  {
	    if ( ( numentints == 0 ) ) 
	    {
	      (void) Fputs( logfile ,  " undefined" ) ; 
	    } 
	    else if ( ( ! readcompleted ) ) 
	    {
	      (void) Fputs( logfile ,  " uninitialized" ) ; 
	    } 
	    else {
		
	      intentptr = citeptr * numentints ; 
	      while ( ( intentptr < ( citeptr + 1 ) * numentints ) ) {
		  
		{
		  (void) fprintf( logfile , "%c%ld",  ' ' , (long)entryints [ intentptr ] ) ; 
		} 
		incr ( intentptr ) ; 
	      } 
	    } 
	    {
	      (void) putc('\n',  logfile );
	    } 
	  } 
	  {
	    (void) fprintf( logfile , "%s\n",  "  and has fields" ) ; 
	  } 
	  {
	    if ( ( ! readperformed ) ) 
	    {
	      (void) fprintf( logfile , "%s\n",  "    uninitialized" ) ; 
	    } 
	    else {
		
	      fieldptr = citeptr * numfields ; 
	      fieldendptr = fieldptr + numfields ; 
	      nofields = true ; 
	      while ( ( fieldptr < fieldendptr ) ) {
		  
		if ( ( fieldinfo [ fieldptr ] != 0 ) ) 
		{
		  {
		    (void) Fputs( logfile ,  "    \"" ) ; 
		  } 
		  {
		    outpoolstr ( logfile , fieldinfo [ fieldptr ] ) ; 
		  } 
		  {
		    (void) fprintf( logfile , "%c\n",  '"' ) ; 
		  } 
		  nofields = false ; 
		} 
		incr ( fieldptr ) ; 
	      } 
	      if ( ( nofields ) ) 
	      {
		(void) fprintf( logfile , "%s\n",  "    missing" ) ; 
	      } 
	    } 
	  } 
	} 
	else {
	    
	  (void) putc('\n',  logfile );
	} 
	incr ( sortciteptr ) ; 
      } 
    } 
  } 
  {
    {
      (void) fprintf( logfile , "%s\n",  "The wiz-defined functions are" ) ; 
    } 
    if ( ( wizdefptr == 0 ) ) 
    {
      (void) fprintf( logfile , "%s\n",  "   nonexistent" ) ; 
    } 
    else {
	
      wizfnptr = 0 ; 
      while ( ( wizfnptr < wizdefptr ) ) {
	  
	if ( ( wizfunctions [ wizfnptr ] == 5001 ) ) 
	{
	  (void) fprintf( logfile , "%ld%s\n",  (long)wizfnptr , "--end-of-def--" ) ; 
	} 
	else if ( ( wizfunctions [ wizfnptr ] == 0 ) ) 
	{
	  (void) fprintf( logfile , "%ld%s",  (long)wizfnptr , "  quote_next_function    " ) ; 
	} 
	else {
	    
	  {
	    (void) fprintf( logfile , "%ld%s",  (long)wizfnptr , "  `" ) ; 
	  } 
	  {
	    outpoolstr ( logfile , hashtext [ wizfunctions [ wizfnptr ] ] ) ; 
	  } 
	  {
	    (void) fprintf( logfile , "%c\n",  '\'' ) ; 
	  } 
	} 
	incr ( wizfnptr ) ; 
      } 
    } 
  } 
  {
    {
      (void) fprintf( logfile , "%s\n",  "The string pool is" ) ; 
    } 
    strnum = 1 ; 
    while ( ( strnum < strptr ) ) {
	
      {
	(void) fprintf( logfile , "%ld%ld%s",  (long)strnum , (long)strstart [ strnum ] , " \"" ) ; 
      } 
      {
	outpoolstr ( logfile , strnum ) ; 
      } 
      {
	(void) fprintf( logfile , "%c\n",  '"' ) ; 
      } 
      incr ( strnum ) ; 
    } 
  } 
#endif /* TRACE */
	;
#ifdef STAT
  {
    {
      (void) fprintf( logfile , "%s%ld",  "You've used " , (long)numcites ) ; 
    } 
    if ( ( numcites == 1 ) ) 
    {
      (void) fprintf( logfile , "%s\n",  " entry," ) ; 
    } 
    else {
	
      (void) fprintf( logfile , "%s\n",  " entries," ) ; 
    } 
    {
      (void) fprintf( logfile , "%s%ld%s\n",  "            " , (long)wizdefptr ,       " wiz_defined-function locations," ) ; 
    } 
    {
      (void) fprintf( logfile , "%s%ld%s%ld%s\n",  "            " , (long)strptr , " strings with " ,       (long)strstart [ strptr ] , " characters," ) ; 
    } 
    bltinptr = 0 ; 
    totalexcount = 0 ; 
    while ( ( bltinptr < numbltinfns ) ) {
	
      totalexcount = totalexcount + executioncount [ bltinptr ] ; 
      incr ( bltinptr ) ; 
    } 
    {
      (void) fprintf( logfile , "%s%ld%s\n",  "and the built_in function-call counts, " ,       (long)totalexcount , " in all, are:" ) ; 
    } 
    bltinptr = 0 ; 
    while ( ( bltinptr < numbltinfns ) ) {
	
      {
	outpoolstr ( logfile , hashtext [ bltinloc [ bltinptr ] ] ) ; 
      } 
      {
	(void) fprintf( logfile , "%s%ld\n",  " -- " , (long)executioncount [ bltinptr ] ) ; 
      } 
      incr ( bltinptr ) ; 
    } 
  } 
#endif /* STAT */
} 
boolean zaopenin ( f ) 
palphafile * f ; 
{register boolean Result; boolean ok  ; 
  if ( testaccess ( 4 , 1 ) ) 
  {
    reset ( *f , realnameoffile ) ; 
    ok = true ; 
  } 
  else ok = false ; 
  Result = ok ; 
  return(Result) ; 
} 
boolean zaopenout ( f ) 
palphafile * f ; 
{register boolean Result; boolean ok  ; 
  if ( testaccess ( 2 , 0 ) ) 
  {
    rewrite ( *f , realnameoffile ) ; 
    ok = true ; 
  } 
  else ok = false ; 
  Result = ok ; 
  return(Result) ; 
} 
zstartname ( filename ) 
strnumber filename ; 
{poolpointer pptr  ; 
  if ( ( ( strstart [ filename + 1 ] - strstart [ filename ] ) > 1024 ) ) 
  {
    {
      (void) Fputs( logfile ,  "File=" ) ; 
      (void) Fputs( stdout ,  "File=" ) ; 
    } 
    printapoolstr ( filename ) ; 
    {
      (void) fprintf( logfile , "%c\n",  ',' ) ; 
      (void) fprintf( stdout , "%c\n",  ',' ) ; 
    } 
    filenmsizeoverflow () ; 
  } 
  nameptr = 0 ; 
  pptr = strstart [ filename ] ; 
  while ( ( pptr < strstart [ filename + 1 ] ) ) {
      
    nameoffile [ nameptr ] = chr ( strpool [ pptr ] ) ; 
    incr ( nameptr ) ; 
    incr ( pptr ) ; 
  } 
  namelength = ( strstart [ filename + 1 ] - strstart [ filename ] ) ; 
} 
zaddextension ( ext ) 
strnumber ext ; 
{poolpointer pptr  ; 
  if ( ( namelength + ( strstart [ ext + 1 ] - strstart [ ext ] ) > 1024 ) ) 
  {
    {
      (void) fprintf( logfile , "%s%c%s",  "File=" , nameoffile , ", extension=" ) ; 
      (void) fprintf( stdout , "%s%c%s",  "File=" , nameoffile , ", extension=" ) ; 
    } 
    printapoolstr ( ext ) ; 
    {
      (void) fprintf( logfile , "%c\n",  ',' ) ; 
      (void) fprintf( stdout , "%c\n",  ',' ) ; 
    } 
    filenmsizeoverflow () ; 
  } 
  nameptr = namelength ; 
  pptr = strstart [ ext ] ; 
  while ( ( pptr < strstart [ ext + 1 ] ) ) {
      
    nameoffile [ nameptr ] = chr ( strpool [ pptr ] ) ; 
    incr ( nameptr ) ; 
    incr ( pptr ) ; 
  } 
  namelength = namelength + ( strstart [ ext + 1 ] - strstart [ ext ] ) ; 
  nameoffile [ namelength ] = ' ' ; 
} 
zaddarea ( area ) 
strnumber area ; 
{poolpointer pptr  ; 
  if ( ( namelength + ( strstart [ area + 1 ] - strstart [ area ] ) > 1024 ) ) 
  {
    {
      (void) Fputs( logfile ,  "File=" ) ; 
      (void) Fputs( stdout ,  "File=" ) ; 
    } 
    printapoolstr ( area ) ; 
    printstr ( nameoffile , ',' ) ; 
    filenmsizeoverflow () ; 
  } 
  nameptr = namelength ; 
  while ( ( nameptr > 0 ) ) {
      
    nameoffile [ nameptr + ( strstart [ area + 1 ] - strstart [ area ] ) ] = 
    nameoffile [ nameptr ] ; 
    decr ( nameptr ) ; 
  } 
  nameptr = 0 ; 
  pptr = strstart [ area ] ; 
  while ( ( pptr < strstart [ area + 1 ] ) ) {
      
    nameoffile [ nameptr ] = chr ( strpool [ pptr ] ) ; 
    incr ( nameptr ) ; 
    incr ( pptr ) ; 
  } 
  namelength = namelength + ( strstart [ area + 1 ] - strstart [ area ] ) ; 
} 
strnumber makestring () {
    register strnumber Result; if ( ( strptr == 
  maxstrings ) ) 
  {
    printoverflow () ; 
    {
      (void) fprintf( logfile , "%s%ld\n",  "number of strings " , (long)maxstrings ) ; 
      (void) fprintf( stdout , "%s%ld\n",  "number of strings " , (long)maxstrings ) ; 
    } 
    longjmp(jmp9998,1) ; 
  } 
  incr ( strptr ) ; 
  strstart [ strptr ] = poolptr ; 
  Result = strptr - 1 ; 
  return(Result) ; 
} 
boolean zstreqbuf ( s , buf , bfptr , len ) 
strnumber s ; 
buftype buf ; 
bufpointer bfptr , len ; 
{/* 10 */ register boolean Result; bufpointer i  ; 
  poolpointer j  ; 
  if ( ( ( strstart [ s + 1 ] - strstart [ s ] ) != len ) ) 
  {
    Result = false ; 
    goto lab10 ; 
  } 
  i = bfptr ; 
  j = strstart [ s ] ; 
  while ( ( j < strstart [ s + 1 ] ) ) {
      
    if ( ( strpool [ j ] != buf [ i ] ) ) 
    {
      Result = false ; 
      goto lab10 ; 
    } 
    incr ( i ) ; 
    incr ( j ) ; 
  } 
  Result = true ; 
  lab10: ; 
  return(Result) ; 
} 
boolean zstreqstr ( s1 , s2 ) 
strnumber s1 , s2 ; 
{/* 10 */ register boolean Result; if ( ( ( strstart [ s1 + 1 ] - 
  strstart [ s1 ] ) != ( strstart [ s2 + 1 ] - strstart [ s2 ] ) ) ) 
  {
    Result = false ; 
    goto lab10 ; 
  } 
  pptr1 = strstart [ s1 ] ; 
  pptr2 = strstart [ s2 ] ; 
  while ( ( pptr1 < strstart [ s1 + 1 ] ) ) {
      
    if ( ( strpool [ pptr1 ] != strpool [ pptr2 ] ) ) 
    {
      Result = false ; 
      goto lab10 ; 
    } 
    incr ( pptr1 ) ; 
    incr ( pptr2 ) ; 
  } 
  Result = true ; 
  lab10: ; 
  return(Result) ; 
} 
zlowercase ( buf , bfptr , len ) 
buftype buf ; 
bufpointer bfptr , len ; 
{bufpointer i  ; 
  if ( ( len > 0 ) ) 
  {register integer for_end; i = bfptr ; for_end = bfptr + len - 1 ; if ( i 
  <= for_end) do 
    if ( ( ( buf [ i ] >= 65 ) && ( buf [ i ] <= 90 ) ) ) 
    buf [ i ] = buf [ i ] + 32 ; 
  while ( i++ < for_end ) ; } 
} 
zuppercase ( buf , bfptr , len ) 
buftype buf ; 
bufpointer bfptr , len ; 
{bufpointer i  ; 
  if ( ( len > 0 ) ) 
  {register integer for_end; i = bfptr ; for_end = bfptr + len - 1 ; if ( i 
  <= for_end) do 
    if ( ( ( buf [ i ] >= 97 ) && ( buf [ i ] <= 122 ) ) ) 
    buf [ i ] = buf [ i ] - 32 ; 
  while ( i++ < for_end ) ; } 
} 
hashloc zstrlookup ( buf , j , l , ilk , insertit ) 
buftype buf ; 
bufpointer j , l ; 
strilk ilk ; 
boolean insertit ; 
{/* 40 45 */ register hashloc Result; short h  ; 
  hashloc p  ; 
  bufpointer k  ; 
  boolean oldstring  ; 
  strnumber strnum  ; 

  {
    h = 0 ; 
    k = j ; 
    while ( ( k < j + l ) ) {
	
      h = h + h + buf [ k ] ; 
      while ( ( h >= 4253 ) ) h = h - 4253 ; 
      incr ( k ) ; 
    } 
  } 
  p = h + 1 ; 
  hashfound = false ; 
  oldstring = false ; 
  while ( true ) {
      
    {
      if ( ( hashtext [ p ] > 0 ) ) 
      if ( ( streqbuf ( hashtext [ p ] , buf , j , l ) ) ) 
      if ( ( hashilk [ p ] == ilk ) ) 
      {
	hashfound = true ; 
	goto lab40 ; 
      } 
      else {
	  
	oldstring = true ; 
	strnum = hashtext [ p ] ; 
      } 
    } 
    if ( ( hashnext [ p ] == 0 ) ) 
    {
      if ( ( ! insertit ) ) 
      goto lab45 ; 
      {
	if ( ( hashtext [ p ] > 0 ) ) 
	{
	  do {
	      if ( ( ( hashused == 1 ) ) ) 
	    {
	      printoverflow () ; 
	      {
		(void) fprintf( logfile , "%s%ld\n",  "hash size " , (long)5000 ) ; 
		(void) fprintf( stdout , "%s%ld\n",  "hash size " , (long)5000 ) ; 
	      } 
	      longjmp(jmp9998,1) ; 
	    } 
	    decr ( hashused ) ; 
	  } while ( ! ( ( hashtext [ hashused ] == 0 ) ) ) ; 
	  hashnext [ p ] = hashused ; 
	  p = hashused ; 
	} 
	if ( ( oldstring ) ) 
	hashtext [ p ] = strnum ; 
	else {
	    
	  {
	    if ( ( poolptr + l > poolsize ) ) 
	    pooloverflow () ; 
	  } 
	  k = j ; 
	  while ( ( k < j + l ) ) {
	      
	    {
	      strpool [ poolptr ] = buf [ k ] ; 
	      incr ( poolptr ) ; 
	    } 
	    incr ( k ) ; 
	  } 
	  hashtext [ p ] = makestring () ; 
	} 
	hashilk [ p ] = ilk ; 
      } 
      goto lab40 ; 
    } 
    p = hashnext [ p ] ; 
  } 
  lab45: ; 
  lab40: Result = p ; 
  return(Result) ; 
} 
zpredefine ( pds , len , ilk ) 
pdstype pds ; 
pdslen len ; 
strilk ilk ; 
{pdslen i  ; 
  {register integer for_end; i = 1 ; for_end = len ; if ( i <= for_end) do 
    buffer [ i ] = xord [ pds [ i - 1 ] ] ; 
  while ( i++ < for_end ) ; } 
  predefloc = strlookup ( buffer , 1 , len , ilk , true ) ; 
} 
zinttoASCII ( inte , intbuf , intbegin , intend ) 
integer inte ; 
buftype intbuf ; 
bufpointer intbegin ; 
bufpointer * intend ; 
{bufpointer intptr, intxptr  ; 
  ASCIIcode inttmpval  ; 
  intptr = intbegin ; 
  if ( ( inte < 0 ) ) 
  {
    {
      if ( ( intptr == bufsize ) ) 
      bufferoverflow () ; 
      intbuf [ intptr ] = 45 ; 
      incr ( intptr ) ; 
    } 
    inte = - (integer) inte ; 
  } 
  intxptr = intptr ; 
  do {
      { 
      if ( ( intptr == bufsize ) ) 
      bufferoverflow () ; 
      intbuf [ intptr ] = 48 + ( inte % 10 ) ; 
      incr ( intptr ) ; 
    } 
    inte = inte / 10 ; 
  } while ( ! ( ( inte == 0 ) ) ) ; 
*  intend = intptr ; 
  decr ( intptr ) ; 
  while ( ( intxptr < intptr ) ) {
      
    inttmpval = intbuf [ intxptr ] ; 
    intbuf [ intxptr ] = intbuf [ intptr ] ; 
    intbuf [ intptr ] = inttmpval ; 
    decr ( intptr ) ; 
    incr ( intxptr ) ; 
  } 
} 
zadddatabasecite ( newcite ) 
citenumber * newcite ; 
{checkciteoverflow ( *newcite ) ; 
  checkfieldoverflow ( numfields * *newcite ) ; 
  citelist [ *newcite ] = hashtext [ citeloc ] ; 
  ilkinfo [ citeloc ] = *newcite ; 
  ilkinfo [ lcciteloc ] = citeloc ; 
  incr ( *newcite ) ; 
} 
boolean zfindcitelocsforthisc ( citestr ) 
strnumber citestr ; 
{register boolean Result; exbufptr = 0 ; 
  tmpptr = strstart [ citestr ] ; 
  tmpendptr = strstart [ citestr + 1 ] ; 
  while ( ( tmpptr < tmpendptr ) ) {
      
    exbuf [ exbufptr ] = strpool [ tmpptr ] ; 
    incr ( exbufptr ) ; 
    incr ( tmpptr ) ; 
  } 
  citeloc = strlookup ( exbuf , 0 , ( strstart [ citestr + 1 ] - strstart [ 
  citestr ] ) , 9 , false ) ; 
  citehashfound = hashfound ; 
  lowercase ( exbuf , 0 , ( strstart [ citestr + 1 ] - strstart [ citestr ] ) 
  ) ; 
  lcciteloc = strlookup ( exbuf , 0 , ( strstart [ citestr + 1 ] - strstart [ 
  citestr ] ) , 10 , false ) ; 
  if ( ( hashfound ) ) 
  Result = true ; 
  else Result = false ; 
  return(Result) ; 
} 
zswap ( swap1 , swap2 ) 
citenumber swap1 , swap2 ; 
{citenumber innocentbystander  ; 
  innocentbystander = citeinfo [ swap2 ] ; 
  citeinfo [ swap2 ] = citeinfo [ swap1 ] ; 
  citeinfo [ swap1 ] = innocentbystander ; 
} 
boolean zlessthan ( arg1 , arg2 ) 
citenumber arg1 , arg2 ; 
{/* 10 */ register boolean Result; integer charptr  ; 
  strentloc ptr1, ptr2  ; 
  ASCIIcode char1, char2  ; 
  ptr1 = arg1 * numentstrs + sortkeynum ; 
  ptr2 = arg2 * numentstrs + sortkeynum ; 
  charptr = 0 ; 
  while ( true ) {
      
    char1 = entrystrs [ ptr1 ] [ charptr ] ; 
    char2 = entrystrs [ ptr2 ] [ charptr ] ; 
    if ( ( char1 == 127 ) ) 
    if ( ( char2 == 127 ) ) 
    if ( ( arg1 < arg2 ) ) 
    {
      Result = true ; 
      goto lab10 ; 
    } 
    else if ( ( arg1 > arg2 ) ) 
    {
      Result = false ; 
      goto lab10 ; 
    } 
    else {
	
      {
	(void) Fputs( logfile ,  "Duplicate sort key" ) ; 
	(void) Fputs( stdout ,  "Duplicate sort key" ) ; 
      } 
      printconfusion () ; 
      longjmp(jmp9998,1) ; 
    } 
    else {
	
      Result = true ; 
      goto lab10 ; 
    } 
    else if ( ( char2 == 127 ) ) 
    {
      Result = false ; 
      goto lab10 ; 
    } 
    else if ( ( char1 < char2 ) ) 
    {
      Result = true ; 
      goto lab10 ; 
    } 
    else if ( ( char1 > char2 ) ) 
    {
      Result = false ; 
      goto lab10 ; 
    } 
    incr ( charptr ) ; 
  } 
  lab10: ; 
  return(Result) ; 
} 
zquicksort ( leftend , rightend ) 
citenumber leftend , rightend ; 
{/* 24 */ citenumber left, right  ; 
  citenumber insertptr  ; 
  citenumber middle  ; 
  citenumber partition  ; 
	;
#ifdef TRACE
  {
    (void) fprintf( logfile , "%s%ld%s%ld\n",  "Sorting " , (long)leftend , " through " , (long)rightend ) ; 
  } 
#endif /* TRACE */
  if ( ( rightend - leftend < 10 ) ) 
  {
    {register integer for_end; insertptr = leftend + 1 ; for_end = rightend 
    ; if ( insertptr <= for_end) do 
      {
	{register integer for_end; right = insertptr ; for_end = leftend + 1 
	; if ( right >= for_end) do 
	  {
	    if ( ( lessthan ( citeinfo [ right - 1 ] , citeinfo [ right ] ) ) 
	    ) 
	    goto lab24 ; 
	    swap ( right - 1 , right ) ; 
	  } 
	while ( right-- > for_end ) ; } 
	lab24: ; 
      } 
    while ( insertptr++ < for_end ) ; } 
  } 
  else {
      
    {
      left = leftend + 4 ; 
      middle = ( leftend + rightend ) / 2 ; 
      right = rightend - 4 ; 
      if ( ( lessthan ( citeinfo [ left ] , citeinfo [ middle ] ) ) ) 
      if ( ( lessthan ( citeinfo [ middle ] , citeinfo [ right ] ) ) ) 
      swap ( leftend , middle ) ; 
      else if ( ( lessthan ( citeinfo [ left ] , citeinfo [ right ] ) ) ) 
      swap ( leftend , right ) ; 
      else swap ( leftend , left ) ; 
      else if ( ( lessthan ( citeinfo [ right ] , citeinfo [ middle ] ) ) ) 
      swap ( leftend , middle ) ; 
      else if ( ( lessthan ( citeinfo [ right ] , citeinfo [ left ] ) ) ) 
      swap ( leftend , right ) ; 
      else swap ( leftend , left ) ; 
    } 
    {
      partition = citeinfo [ leftend ] ; 
      left = leftend + 1 ; 
      right = rightend ; 
      do {
	  while ( ( lessthan ( citeinfo [ left ] , partition ) ) ) incr ( 
	left ) ; 
	while ( ( lessthan ( partition , citeinfo [ right ] ) ) ) decr ( right 
	) ; 
	if ( ( left < right ) ) 
	{
	  swap ( left , right ) ; 
	  incr ( left ) ; 
	  decr ( right ) ; 
	} 
      } while ( ! ( ( left == right + 1 ) ) ) ; 
      swap ( leftend , right ) ; 
      quicksort ( leftend , right - 1 ) ; 
      quicksort ( left , rightend ) ; 
    } 
  } 
} 
